#include <windows.h>
#include "comm.h"
#include <stdio.h>

HANDLE hCom=NULL;
int error=0;

void InitCom(int n)
{
    char name[8];
    DCB dcb;

    error=0;
    sprintf(name,"COM%d:",n);
    hCom=CreateFile(name,GENERIC_READ|GENERIC_WRITE,0,NULL,
        OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (!hCom)
    {
        MessageBox(NULL,"Error opening COM port","Error",MB_OK);
        error=1;
        return;
    }
    dcb.DCBlength=sizeof(DCB);
    dcb.BaudRate=CBR_9600; dcb.ByteSize=8; dcb.Parity=0;
    dcb.StopBits=0;
    dcb.fNull=0; dcb.fBinary=1; dcb.fParity=0;
    dcb.fOutxCtsFlow=1; dcb.fOutxDsrFlow=1;
    dcb.fDtrControl=0; dcb.fOutX=0; dcb.fInX=0;
    dcb.fErrorChar=0; dcb.fRtsControl=RTS_CONTROL_ENABLE;
    SetupComm(hCom,1024,1024);
    GetCommState(hCom,&dcb);
    BuildCommDCB("COM1: baud=9600 parity=N data=8 stop=1",&dcb);
    dcb.fNull=0;    
    SetCommState(hCom,&dcb);
    COMMTIMEOUTS to;
    to.ReadIntervalTimeout=2000;
    to.ReadTotalTimeoutMultiplier=0;
    to.ReadTotalTimeoutConstant=2000;
    to.WriteTotalTimeoutMultiplier=0;
    to.WriteTotalTimeoutConstant=2000;
    SetCommTimeouts(hCom,&to);
}

void CloseCom()
{
	if (hCom) CloseHandle(hCom);
}

void SendCom(int ch)
{
	if (error) return;
    DWORD i;
    WriteFile(hCom,&ch,1,&i,NULL);
    if (i!=1) error=1;
}

int GetCom(int &ch)
{
	if (error) return 0;
    DWORD i;
    unsigned char c;
    ReadFile(hCom,&c,1,&i,NULL);
    ch=c;
    if (i!=1) error=1;
    return i;
}

int ComError()
{
	return error;
}

void ResetError()
{
    error=0;
}

