//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "DumpRecvWin.h"
#include "RecvThread.h"
#include "COMSelect.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TrecvWnd *recvWnd;
extern int Terminated;
extern int comPort;
//---------------------------------------------------------------------------
__fastcall TrecvWnd::TrecvWnd(TComponent* Owner)
    : TForm(Owner)
{
    size=0;
}
//---------------------------------------------------------------------------

void __fastcall TrecvWnd::SetSize(int len)
{
	size=len;
    bytes=0;
    ProgressBar->Step=1024;
    ProgressBar->Max=size;
    ProgressBar->Position=0;
    char str[48];
    sprintf(str,"0K of %dK transfered",size/1024);
    Label->Caption=str;
}

void __fastcall TrecvWnd::ErrorMsg()
{
	Label->Caption="Transmission error.  Check connection.";
}

void __fastcall TrecvWnd::UpdateProgress()
{
    bytes++;
    if (!(bytes&1023))
    {
    	ProgressBar->StepIt();
	    char str[48];
	    sprintf(str,"%dK of %dK transfered",bytes/1024,size/1024);
	    Label->Caption=str;
    }
}


void __fastcall TrecvWnd::FormCreate(TObject *Sender)
{
    comPort=new TSelectDlg(this)->ShowModal();
	new RecieveThread(false);
}
//---------------------------------------------------------------------------

void __fastcall TrecvWnd::FormClose(TObject *Sender, TCloseAction &Action)
{
    Terminated=1;
}
//---------------------------------------------------------------------------
void __fastcall TrecvWnd::GetSaveName(char *name)
{
    if (size==0x40000)
        SaveDialog->FileName="ram.dmp";
    else
        SaveDialog->FileName="rom.dmp";
    if (SaveDialog->Execute())
        strcpy(name,SaveDialog->FileName.c_str());
    else
        name[0]=0;
}

