//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "DumpRecvWin.h"
#include "RecvThread.h"
#include "Comm.h"
#pragma package(smart_init)

#define ROM 0
#define RAM 1
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall RecieveThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
int Terminated=0;
int comPort=1;

__fastcall RecieveThread::RecieveThread(bool CreateSuspended)
    : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------

void __fastcall RecieveThread::UpdateSize()
{
	recvWnd->SetSize(size);
}

void __fastcall RecieveThread::UpdateProgress()
{
	recvWnd->UpdateProgress();
}

void __fastcall RecieveThread::Complete()
{
	recvWnd->Visible=false;
    recvWnd->Close();
}

void __fastcall RecieveThread::ErrorMsg()
{
	recvWnd->ErrorMsg();
}

void __fastcall RecieveThread::GetSaveName()
{
    recvWnd->GetSaveName(name);
}
//---------------------------------------------------------------------------
void __fastcall RecieveThread::Execute()
{
	//---- Place thread code here ----
    int csum,i,j,c,dump;

    if (comPort==-1)
    {
        Synchronize(Complete);
        return;
    }
    while(1)
    {
    	if (Terminated) return;
		InitCom(comPort);
        while (1)
        {
            if (Terminated) return;
            GetCom(c);
            if (ComError())
            {
                ResetError();
                continue;
            }
            if (c=='R')
            {
                GetCom(c);
                if (c=='A') dump=RAM;
                else if (c=='O') dump=ROM;
                else continue;
                GetCom(c);
                if (c!='M') continue;
                GetCom(c);
                if (c==' ') break;
            }
        }
        if (dump==RAM) size=0x40000;
        else size=0x200000;
        Synchronize(UpdateSize);
        unsigned char *dump=new unsigned char[size];
	    csum=0;
	    for (i=0;i<size;i++)
	    {
	    	if (Terminated) return;
	    	GetCom(c);
            dump[i]=c;
	        csum+=c;
            if (!((i+1)&0xfff))
            {
                GetCom(c);
                j=c;
                GetCom(c);
                j|=c<<8;
                if (j!=(csum&0xffff))
                    error=1;
                csum=0;
            }
            if (!ComError())
				Synchronize(UpdateProgress);
	    }
        if (ComError())
        {
            Synchronize(ErrorMsg);
            continue;
        }
        CloseCom();
        Synchronize(GetSaveName);
        if (name[0]==0) break;
        FILE *fp=fopen(name,"wb");
        fwrite(dump,size,1,fp);
        fclose(fp);
        delete[] dump;
        break;
    }
    Synchronize(Complete);
}

